package banco.cliente;

public class CadastroClientes {

  private IRepositorioClientes clientes;

  public CadastroClientes(IRepositorioClientes r) {
	if (r == null) {
	  throw new IllegalArgumentException("Argumento lista clientes nula");
	}
	this.clientes = r;
  }
  public void atualizar(Cliente c) throws ClienteInexistenteException{
	  clientes.atualizar(c);
  }
  public void inserir(Cliente c) throws ClienteExistenteException{
    String cpf = c.getCpf();
    if (!clientes.existe(cpf)) {
      clientes.inserir(c);
    } else {
	  throw new ClienteExistenteException("Cliente nao encontrado");
    }
  }
  public void remover(String cpf) throws ClienteInexistenteException{
	  clientes.remover(cpf);
  }
  public Cliente procurar(String cpf) throws ClienteInexistenteException{
	return clientes.procurar(cpf);
  }
}
