package banco.conta;

public class CadastroContas {
	private IRepositorioContas contas;

	public CadastroContas(IRepositorioContas r) {
	  if (r == null) {
		throw new IllegalArgumentException("Argumento repositorioContas nulo");
	  }
	  this.contas = r;
	}

	public void atualizar(ContaAbstrata c) throws ContaInexistenteException {
  	  contas.atualizar(c);
	}
	public void inserir(ContaAbstrata c) throws ContaExistenteException{
          if(!contas.existe(c.getNumero())){
	    contas.inserir(c);
          }else{
	    throw new ContaExistenteException(c.getNumero());
	  }
        }

	public void creditar(String n, double v)
          throws ContaInexistenteException{

	  ContaAbstrata c = contas.procurar(n);
	  c.creditar(v);
	}

	public void debitar(String n, double v)
          throws ContaInexistenteException, SaldoInsuficienteException{

	  ContaAbstrata c = contas.procurar(n);
	  c.debitar(v);
	}

	public void remover(String n) throws ContaInexistenteException{
  	  contas.remover(n);
	}

	public ContaAbstrata procurar(String n) throws ContaInexistenteException{
	  return contas.procurar(n);
	}

	public void transferir(String origem, String destino, double val)
          throws ContaInexistenteException, SaldoInsuficienteException{

	  ContaAbstrata o = contas.procurar(origem);
	  ContaAbstrata d = contas.procurar(destino);
	  o.transferir(d,val);
	}

        public ColecaoContasIteravel procurarContas(String cpfCliente){
          return contas.procurarContas(cpfCliente);
        }
}
