package banco.conta;

import banco.cliente.*;

public class ContaImposto extends ContaAbstrata {

  public static final double TAXA = 0.001;

  public ContaImposto(String n) {
    super (n);
  }
  public ContaImposto(String n,double s) {
    super (n,s);
  }
  public ContaImposto(String n,double s, Cliente c) {
    super (n,s,c);
  }

  public void debitar(double valor) throws SaldoInsuficienteException{
    double imposto = valor + (valor * TAXA);
    double saldo = this.getSaldo();
    if(imposto <= saldo){
      this.setSaldo(saldo - imposto);
    }else{
      throw new SaldoInsuficienteException("Saldo insuficiente");
    }
  }
}