package banco.gui;

import javax.swing.*;
import java.awt.*;
import banco.fachada.*;
import banco.cliente.*;
import banco.conta.*;
import java.awt.event.*;

public class FrameCliente extends JFrame{
  JButton btInserir = new JButton();
  JLabel labelCpf = new JLabel();
  JLabel labelNome = new JLabel();
  JTextField tfCpf = new JTextField();
  JTextField tfNome = new JTextField();
  JButton btRemover = new JButton();
  JButton btProcurar = new JButton();
  JButton btAtualizar = new JButton();
  JButton btFechar = new JButton();
  Fachada fachada;
  JLabel lbContas = new JLabel();
  JScrollPane scrollContas = new JScrollPane();
  JList listContas = new JList();

  public FrameCliente(Fachada f) {
    this.fachada = f;
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    btInserir.setMargin(new Insets(2, 4, 2, 4));
    btInserir.setText("Inserir");
    btInserir.setBounds(new Rectangle(12, 230, 68, 29));
    btInserir.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btInserir_actionPerformed(e);
      }
    });
    this.getContentPane().setLayout(null);
    labelCpf.setText("CPF:");
    labelCpf.setBounds(new Rectangle(22, 49, 41, 17));
    labelNome.setBounds(new Rectangle(22, 79, 41, 17));
    labelNome.setText("Nome:");
    tfCpf.setBounds(new Rectangle(86, 44, 104, 22));
    tfNome.setBounds(new Rectangle(86, 74, 307, 22));
    btRemover.setBounds(new Rectangle(88, 230, 68, 29));
    btRemover.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btRemover_actionPerformed(e);
      }
    });
    btRemover.setText("Remover");
    btRemover.setMargin(new Insets(2, 4, 2, 4));
    btProcurar.setBounds(new Rectangle(165, 230, 68, 29));
    btProcurar.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btProcurar_actionPerformed(e);
      }
    });
    btProcurar.setText("Procurar");
    btProcurar.setMargin(new Insets(2, 4, 2, 4));
    btAtualizar.setBounds(new Rectangle(242, 230, 68, 29));
    btAtualizar.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btAtualizar_actionPerformed(e);
      }
    });
    btAtualizar.setText("Atualizar");
    btAtualizar.setMargin(new Insets(2, 4, 2, 4));
    btFechar.setBounds(new Rectangle(320, 230, 68, 29));
    btFechar.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btFechar_actionPerformed(e);
      }
    });
    btFechar.setText("Fechar");
    btFechar.setMargin(new Insets(2, 4, 2, 4));
    this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    lbContas.setText("Contas:");
    lbContas.setBounds(new Rectangle(21, 116, 58, 21));
    scrollContas.setBounds(new Rectangle(85, 118, 206, 92));
    this.getContentPane().add(labelCpf, null);
    this.getContentPane().add(tfCpf, null);
    this.getContentPane().add(labelNome, null);
    this.getContentPane().add(tfNome, null);
    this.getContentPane().add(btFechar, null);
    this.getContentPane().add(btInserir, null);
    this.getContentPane().add(btRemover, null);
    this.getContentPane().add(btProcurar, null);
    this.getContentPane().add(btAtualizar, null);
    this.getContentPane().add(lbContas, null);
    this.getContentPane().add(scrollContas, null);
    scrollContas.getViewport().add(listContas, null);
  }

  private void limparCampos(){
    tfCpf.setText("");
    tfNome.setText("");
    listContas.setModel(new DefaultListModel());
  }

  void btInserir_actionPerformed(ActionEvent e) {
    String cpf = tfCpf.getText();
    String nome = tfNome.getText();
    try{
      Cliente novo = new Cliente(cpf,nome);
      fachada.inserir(novo);
      limparCampos();
    }catch(ClienteExistenteException ex){
      JOptionPane.showMessageDialog(this,ex.getMessage(), "Erro de insercao",JOptionPane.OK_OPTION);
    }
  }

  void btRemover_actionPerformed(ActionEvent e) {
    String cpf = tfCpf.getText();
    try {
      fachada.removerCliente(cpf);
    }catch (ClienteInexistenteException ex) {
      JOptionPane.showMessageDialog(this,ex.getMessage(), "Erro de remocao",JOptionPane.OK_OPTION);
    }

  }

  void btProcurar_actionPerformed(ActionEvent e) {
    String cpf = tfCpf.getText();
    try {
      Cliente proc = fachada.procurarCliente(cpf);
      tfNome.setText(proc.getNome());
      DefaultListModel model = new DefaultListModel();
      ColecaoContasIteravel contas = fachada.procurarContas(cpf);
      while(contas.hasNext()){
        model.addElement(contas.next());
      }
      listContas.setModel(model);
    }catch (ClienteInexistenteException ex) {
      JOptionPane.showMessageDialog(this,ex.getMessage(), "Erro de procura",JOptionPane.OK_OPTION);
    }

  }

  void btAtualizar_actionPerformed(ActionEvent e) {
    String cpf = tfCpf.getText();
    String nome = tfNome.getText();
    try{
      Cliente atualizado = new Cliente(cpf,nome);
      fachada.atualizar(atualizado);
      limparCampos();
    }catch(ClienteInexistenteException ex){
      JOptionPane.showMessageDialog(this,ex.getMessage(), "Erro de atualizacao",JOptionPane.OK_OPTION);
    }
  }

  void btFechar_actionPerformed(ActionEvent e) {
    this.dispose();
  }
}